/*
 * NetworkTopology.h
 *
 *  Created on: 09.04.2009
 *      Author: ingmar
 */

#ifndef NETWORKTOPOLOGY_H_
#define NETWORKTOPOLOGY_H_

#include <map>
#include <list>
#include "RTDS_gen.h"
#include "Common.h"


class NetworkTopology {
private:
	ID myID;
	RTDS_QueueId myReceiverReference;
	std::map<ID, double> connectivityMap;
	
	std::map<ID, RTDS_QueueId> transportReceiverReferences;
  std::map<ID, RTDS_QueueId> transportSenderReferences;

	std::map<RTDS_QueueId, ID> nodeIds;
	
public:

	NetworkTopology();
	virtual ~NetworkTopology();

	void setMyId(ID id);
	ID getMyId() const;
	
	void setMyReceiverReference(RTDS_QueueId reference) ;
	RTDS_QueueId getMyReceiverReference() const;

	double getConnectivity(ID id) ;
	double getConnectivity(RTDS_QueueId teRef);

	void setIdReferenceMapping(ID id, RTDS_QueueId receiver_reference, RTDS_QueueId sender_reference);
	void setConnectivity(ID id, double connectivity);
	
	std::list<RTDS_QueueId> getAllConnectedReferences();
	RTDS_QueueId getReceiverReference(ID id);
	RTDS_QueueId getSenderReference(ID id);

  ID getIDbyReference(RTDS_QueueId reference);
};

typedef NetworkTopology* NetworkTopologyPtr;

#endif /* NETWORKTOPOLOGY_H_ */
